getAImove:
	xor a
	ld (AIjump), a
	ld (AIkick), a
	ld (AIpunch), a
	ld (keyvar), a
	ld a, (char1jump)					;jumping over character?
	or a
	jr nz, nomovexor
	ld a, (char2jump)					;walking under character?
	or a
	jr nz, nomovexor
nojchar1b:
	ld hl, char2x
	ld a, (char1x)
	ld c, a
	ld a, (hl)						;if 'xorred out' get out immediately
	sub c
	add a, 5
	cp 11
	jr nc, nomovexor
	ld b, 4
	jp moveaway
nomovexor:
	ld a, (difficulty)
	cp 3
	jp z, trainingmoving
	and %00000001
	ld b, a
	ld a, r
	and b
	jr nz, nopunchdanger
	ld a, (char2punchspeed)
	dec a
	ld c, a
	ld a, (char2punch)				;check if punch is on
	cp c
	jr z, punchdanger
	ld a, (char2kickspeed)
	dec a
	ld c, a
	ld a, (char2kick)				;check if kick is on (not jump kick)
	cp c
	jr nz, nopunchdanger
punchdanger:
	ld a, (char2x)					;check if other char is close
	ld c, a
	ld a, (char1x)
	sub c
	add a, 16
	cp 32
	jr nc, nopunchdanger
	ld b, 10
	jp moveaway						;else get out of the way
nopunchdanger:
	ld a, (char2kick)				;check if kick is on (not jump kick)
	cp 99
	jr nz, nokjdanger				;kick jump
	ld a, (char2x)					;check if other char is close
	ld c, a
	ld a, (char1x)
	sub c
	add a, 32
	cp 64
	jr nc, nokjdanger
	ld a, (difficulty)
	and %00000001
	ld b, a
	ld a, r
	and b
	jr nz, nokjdanger
	ld b, 2
	jp moveaway						;else get out of the way
nokjdanger:
	ld a, (char1punch)
	or a
	jp nz, immediateaction
	ld hl, char1x
	ld a, (AIgoal)
	cp (hl)
	jp nz, nodoattack
	ld a, (AIattack)
	or a
	jr nz, nostartattack
	xor a
	ld (AIsteps), a
	ld a, r
	and %00000111
	inc a
	ld (AIattack), a
nostartattack:
	cp 1
	jp z, attackseq1
	cp 2
	jp z, attackseq2
	cp 3
	jp z, attackseq3
	cp 4
	jp z, attackseq4
	cp 5
	jp z, attackseq1
	cp 6
	jp z, attackseq6
	cp 7
	jp z, attackseq7
	cp 8
	jp z, attackseq4						;rest twice as much as everything
nodoattack:
	ld a, r
	and %00011111
	cp 13
	jr nz, immediateaction
	xor a
	ld (AIattack), a
	ld (AIkick), a
	ld (AIpunch), a
immediateaction:
	call checkgoal
	call moveit
	ret

moveaway:
	ld a, (char1x)
	ld c, a
	ld a, (char2x)						;else we set the moving goal farther away, result:....
	cp c							;no collision
	jr c, backwardset
	ld a, c
	sub b
	ld (AIgoal), a
	jp immediateaction				;skip the formalities
backwardset:
	ld a, c
	add a, b
	ld (AIgoal), a
	jp immediateaction

checkgoal:
	ld a, (AIgoal)					;if AI trys to escape past edges of screen, jump to middle
	cp 111
	ret c
	ld a, 63				;char2 is on odd numbers
	ld (AIgoal), a
	ld a, 1
	ld (AIjump), a
	ret

attackseq1:
	ld hl, AIsteps
	ld a, (hl)
	inc (hl)
	or a
	jr z, addhitgoal
	ld (AIkick), a
	xor a
	ld (AIattack), a
	jp immediateaction

attackseq2:
	ld a, (char1x)
	ld b, a
	ld hl, AIsteps
	ld a, (hl)
	or a
	jr z, goto36beforechar
	cp 1
	jr z, startjandgoto18
	cp 2
	jr z, startjkickandfinish
	cp 10
	jr c, waitabit
	xor a
	ld (AIattack), a
bfss2:
	inc (hl)
	jp immediateaction
goto36beforechar:
	ld a, (char2x)
	sub 37
	call c, add72
	ld (AIgoal), a
	jr bfss2
add72:
	add a, 72
	ret
startjandgoto18
	ld a, (char2x)
	cp b
	call nc, sub34
	add a, 21
	ld (AIgoal), a
	ld a, 1
	ld (AIjump), a
	jr bfss2
sub34
	sub 42
	ret
startjkickandfinish:
	ld a, 1
	ld (AIkick), a
addhitgoal:
	ld a, (char2x)
	cp b
	call nc, sub14
	add a, 7
	ld (AIgoal), a
	jr bfss2
sub14:
	sub 14
	ret
waitabit:
	jr bfss2

attackseq3:
	ld hl, AIsteps
	ld a, (hl)
	cp 0
	jr z, gotopunch
	cp 1
	jr z, waittilljp0
	cp 2
	jr z, punchit
	cp 3
	jr z, waittillpnch0
	xor a
	ld (AIattack), a
	jp immediateaction
gotopunch:
	ld a, (char1x)
	ld b, a
	jr addhitgoal
waittilljp0
	ld a, (char2jump)
	or a
	jp nz, immediateaction
	jr bfss2
punchit:
	ld a, 1
	ld (AIpunch), a
	jr bfss2
waittillpnch0:
	ld a, (char2punch)
	cp 2
	jp nc, immediateaction
	jr bfss2

attackseq4:
	ld hl, AIsteps
	ld a, (hl)
	cp 0
	jr z, gojumpoverdude
	ld a, 3
	ld (AIattack), a
	ld a, 1
	ld (AIsteps), a
	jp immediateaction
gojumpoverdude:
	ld a, (char1x)
	ld b, a
	ld a, (char2x)
	cp b
	call c, sub14
	add a, 7
	ld (AIgoal), a
	jp bfss2

attackseq6:
	ld a, 1
	ld (AIjump), a
	ld hl, AIsteps
	inc (hl)
	ld a, (hl)
	cp 35
	jr nz, stilljumping
	xor a
	ld (AIattack), a
stilljumping:
	jp immediateaction

attackseq7:
	ld hl, AIsteps
	ld a, (hl)
	or a
	jr z, startwalk
	xor a
	ld (AIattack), a
	jp immediateaction
startwalk:
	inc (hl)
	ld a, (char1x)
	ld b, a
	ld a, 112
	sub b
	ld (AIgoal), a
	jp immediateaction
	
moveit:
	ld a, (AIgoal)
	ld b, a
	ld a, (char1x)
	sub b
	inc a
	cp 3
	jr nc, noassignstuff
    ld a, (char1x)
	ld (AIgoal), a
noassignstuff:
	ld hl, keyvar
	ld a, (char1x)
	ld b, a
	ld a, (AIgoal)
	cp b
	jr z, gonowhere
	jr c, goleft
	ld a, %00100000
	or (hl)
	ld (hl), a
	jr checkifjump
goleft:
	ld a, %01000000
	or (hl)
	ld (hl), a
checkifjump:
	ld a, (char1jump)
	or a
	jr nz, gonowhere
	ld a, (char2jump)
	or a
	jr nz, gonowhere
	ld a, (char1x)
	ld c, a
	ld a, (char2x)
	sub c
	add a, 8
	cp 17
	jr nc, gonowhere
	ld a, 1
	ld (AIjump), a
gonowhere:
	ld a, (AIjump)
	or a
	jr z, nojumpAI
	ld a, %00010000
	or (hl)
	ld (hl), a
nojumpAI
	ld a, (AIkick)
	or a
	jr z, nokickAI
	ld a, %00000100
	or (hl)
	ld (hl), a
nokickAI
	ld a, (AIpunch)
	or a
	jr z, nopunchAI
	ld a, %00000010
	or (hl)
	ld (hl), a
nopunchAI:
	ret

trainingmoving:
	ld a, (char1x)
	ld b, a
	ld a, (AIgoal)
	cp b
	jp nz, moveit
	cp 2
	jr c, setgoalhigh
	ld a, 1
	ld (AIgoal), a
	ret
setgoalhigh:
	ld a, 111
	ld (AIgoal), a
	ret

.end
