#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "King of the Fighters 86",0

ProgStart:
	ld hl, savevar-1						;load save info
	call loadstring
	ld hl, $8100
	ld de, rounds
	ld bc, 25
	ldir
	call _runindicoff
	call clearscreen
	call loadgreyscale
	ld hl, titlepic
	ld de, $fd00
	ld bc, 560
	ldir
	ld hl, titlepic+560
	ld de, $cb00
	ld bc, 560
	ldir
	ld hl, Authorstring
	ld de, $381b
	call drawstring
	ld hl, resetstring
	ld de, $0510
	call drawstring
	call waitkey
pauselp:
	ld b, 1
	call keyloop
	push af
	and %00000010
	call nz, resetstuff
	pop af
	and %00000100
	jr z, pauselp
	ld b, 60
mvtitlelp:
	push bc
	ld hl, $ca10
	ld de, $ca00
	ld bc, 816
	push bc
	ldir
	ld hl, $fc10
	ld de, $fc00
	pop bc
	ldir
	ld b, 50
	call keyloop
	pop bc
	djnz mvtitlelp
backmenu:
	ld a, 1
	ld (selector), a
	ld (match), a
	call closegrey
	call clearscreen
	ld hl, Authorstring
	ld de, $381b
	call drawstring
	ld hl, ShellTitle
	ld de, 0
	call drawstring
menuloop:
	call clearselection
	ld c, 1
	ld hl, Option1
	ld de, $0b10
	call drawmenuopt
	ld de, $1220
	call drawmenuopt
	ld de, $1930
	call drawmenuopt
	ld de, $2040
	call drawmenuopt
	ld de, $2750
	call drawmenuopt
	ld de, $2e60
	call drawmenuopt
menukey:
	ld a, 8
	call hline
	ld a, $35
	call hline
	ld b, 5
	call keyloop
	or a
	jr z, menukey
	ld a, (keyvar)
	push af
	call waitkey
	pop af
	ld b, a
	ld hl, selector
	and %10000000
	call nz, keymenudown
	ld a, b
	and %00010000
	call nz, keymenuup
	ld a, b
	and %00000100
	jr z, menuloop
	ld a, (selector)
	cp 6
	jr z, return
	cp 2
	jp z, exhibition
	ld b, 1
	ld hl, selector
	ld (hl), b
	cp 3
	call z, staminamode
	cp 5
	call z, optionscreen
	cp 1
	call z, tournament
	cp 4
	call z, showhelpabout
	jp backmenu
return:
	ld hl, savevar-1						;save info back into calc
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _ahl_plus_2_pg3
	call _set_abs_dest_addr
	xor a
	ld hl, rounds
	call _set_abs_src_addr
	ld hl, 25
	xor a
	call _set_mm_num_bytes
	call _mm_ldir
	jp _ram_page_1

keymenudown:
	ld a, (hl)
	cp 6
	ret z
	inc (hl)
	ret
keymenuup:
	ld a, (hl)
	dec a
	or a
	ret z
	ld (hl), a
	ret

drawmenuopt:
	ld a, (selector)
	cp c
	jr z, thisisselection
	inc c
	jp drawstring
thisisselection:
	set textInverse, (iy+textflags)
	call drawstring
	res textInverse, (iy+textflags)
	inc c
	ret

exhibition:
	call characterselect
	ld (char1num), a
	ld a, r
	and %00000111
	ld (char2num), a
	call playfight
	jp backmenu

noselectit:
	ld hl, highstring5
	ld de, $1c20
	call drawstring
	call pause
staminamode:
	call characterselect
	cp 8
	jr nc, noselectit
	ld (char1num), a
	ld a, (rounds)
	ld (trounds), a
	ld a, (difficulty)
	ld (tdiff), a
	ld a, 12
	ld (char2num), a
	ld a, 2
	ld (difficulty), a
	dec a
	ld (rounds), a
staminaloop:
	call makeEIstats
	call playfight
	or a
	jr z, deadstamina
	ld a, (match)
	cp 32
	jr z, deadstamina2
	inc a
	ld (match), a
	ld a, (char1health)
	ld (tempstam), a
	jr staminaloop
deadstamina2:
	call clearscreen
	ld hl, highstring4
	ld de, $3801
	call drawstring
	ld a, e
	ld (availablechars+12),a
	jr skipclear
deadstamina:
	call clearscreen
skipclear:
	ld hl, staminahigh
	ld a, (match)
	cp (hl)
	jr z, skiphigh
	call nc, gotahigh
skiphigh:
	ld a, (staminahigh)
	ld l, a
	ld h, 0
	ld bc, $1038
	call drawnumber
	ld hl, highstring1
	ld de, $1010
	call drawstring
	ld d, $20
	call drawstring
	ld a, (match)
	ld l, a
	ld h, 0
	ld bc, $2038
	call drawnumber
	ld a, (trounds)
	ld (rounds), a
	ld a, (tdiff)
	ld (difficulty), a
	jp pause

gotahigh:
	ld (hl), a
	ld hl, highstring3
	ld de, $0110
	jp drawstring
	
makeEIstats:
	ld a, (match)
	ld c, a
	rrc a
	and %00000011
	ld b, a
	inc b
	ld e, %0001001
	xor a
mEIstats:
	or e
	rlc e
	djnz mEIstats
	ld (EIstats+5), a
	ld a, c
	push af
	add a, a
	ld (EIstats), a
	ld (EIstats+1), a
	pop af
	ld b, a
	ld a, 20
	sub b
	jr c, make5
	cp 5
	jr nc, skipmake5
make5:
	ld a, 5
skipmake5
	ld (EIstats+3), a
	ld a, c
	dec a
	rrc a
	rrc a
	and %00000111
	ld b, a
	inc b
	ld a, 33
	ld d, 11
mEIstats2:
	sub 3
	dec d
	djnz mEIstats2
	ld (EIstats+2), a
	ld a, d
	ld (EIstats+4), a
	ret

tempstam:	
	.db 0
trounds:
	.db 0
tdiff:
	.db 0

showhelpabout:
	call clearscreen
	ld hl, helpstring
	ld de, $0600
	call drawstring
	ld d, 12
	call drawstring
	ld d, 18
	call drawstring
	ld d, 24
	call drawstring
	ld d, 30
	call drawstring
	ld d, 36
	call drawstring
	ld d, 42
	call drawstring
	ld d, 48
	call drawstring
	jp pause

helpstring:
	.text "Another great game from Biobytes"
	.text "By: Thomas Williamson"
	.text "Email me at jedivsith@hotmail.com"
	.text "Keys:"
	.text "2nd: Attack 1 (usually kick)"
	.text "Alpha: Attack 2 (usually punch)"
	.text "Up: Jump (slow people jump fast)"
	.text "Graph: Pause (other keys are obvious)"

resetstuff:
	ld hl, resetdata
	ld de, rounds
	ld bc, 25
	ldir
	ld hl, resetstring2
	ld de, $0510
	jp drawstring
	
#include "subroutes.asm"
#include "greyscale.asm"
#include "playfight.asm"
#include "AIfight.asm"
#include "selchar.asm"
#include "optscreen.asm"
#include "tourney.asm"
#include "kotftp.asm"

backdropvar:
savevar:
charactervar:
	.db 8, "kotfdata"
keyvar:
	.db 0
Authorstring:
	.text "By: Thomas Williamson"
Option1:
	.text " Tournament Mode"
	.text " Exhibition"
	.text " Stamina Mode"
	.text " Help / About"
	.text " Options"
	.text " Quit"
selector:
	.db 1
rounds:
	.db 2
speed:
	.db 1
difficulty:
	.db 2
background:
	.db 1, 0
availablechars:
	.db 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0
trainingdiff:
	.db 0
difficultdiff:
	.db 0
doubleaidiff:
	.db 0
twochardiff:
	.db 0
charstatsshow:
	.db 0
losingmessage:
	.db 0
staminahigh:
	.db 0
match:
	.db 1
resetdata:
	.db 2, 1, 2, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
resetstring:
	.text "Press ALPHA to reset save data."
resetstring2:
	.text "------ALL DATA CLEAR------"
highstring1:
	.text "High Score:"
highstring2:
	.text "Score:"
highstring3:
	.text "New High Score!"
highstring4:
	.text "You unlocked EI Stamina!"
highstring5:
	.text "Invalid Character!"

.end
