
playfight:
	xor a
	ld (char1wins), a
	ld (char2wins), a
	ld (curround), a
plfightnewround:
	ld hl, curround
	inc (hl)
	call clearscreen
	call assigndefaults
	ld a, (difficulty)
	cp 4
	jr nz, notondifficult
	ld hl, char2speed
	ld a, (hl)
	or %00101000
	ld (hl), a
	ld hl, char2punchpower
	ld a, (hl)
	add a, 5
	ld (hl), a
	inc hl
	ld a, (hl)
	add a, 5
	ld (hl), a
	inc hl
	inc hl
	dec (hl)
	dec (hl)
	dec (hl)
notondifficult
	call clearbuffer
	call drawchar1b
	call drawchar2b
	call copyscreen
	ld a, (match)
	ld l, a
	ld h, 0
	ld bc, $010d
	call drawnumber
	ld a, (curround)
	ld l, a
	ld h, 0
	ld bc, $013f
	call drawnumber
	ld hl, roundstring
	ld de, $0134
	call drawstring
	ld hl, matchstring
	ld e, 0
	call drawstring
	ld a, (char1num)
	ld de, $083a
	call drawcharname
	ld a, (char2num)
	ld de, $1840
	call drawcharname
	ld hl, vsstring
	ld de, $103d
	call drawstring
	call pause
	call clearscreen
	ld a, (background)
	cp 1
	jr nz, skipbackdrop
	call loadgreyscale
	ld hl, $8100+4145
	ld de, 248
	ld a, (char2num)
	inc a
	ld b, a
getbackpic:
	add hl, de
	djnz getbackpic
	ex de, hl
	call drawbackdrop
skipbackdrop:
	ld a, (char2num)
	cp 12
	jr nz, notonstaminamode
	ld a, (match)
	cp 1
	jr z, notonstaminamode
	ld a, (tempstam)
	ld (char1health), a
	ld (char1goal), a
notonstaminamode:
	call clearbuffer
	call drawchar1b
	call drawchar2b
loopabrag:
	ld hl, mcounter
	rrc (hl)
	call drawchar1
	call movechar1
	call drawchar2
	call movechar2
	ld a, (char1health)
	cp 1
	jr z, deadchar1
	ld a, (char2health)
	cp 1
	jr z, deadcharAI
	call updatehealth
	call copyscreen
	ld b, 1
	ld a, (speed)
	or a
	jr z, onfastmode
	ld b, 10
onfastmode:
	call keyloop
	and %00001000
	jr z, loopabrag
	xor a
	ret
deadchar1:
	call closegrey
	call waitkey
	ld hl, youlosestring
	ld de, $1c38
	call drawstring
	ld b, 50
	call keyloop
	call pause
	ld hl, char2wins
	inc (hl)
	ld a, (rounds)
	cp (hl)
	jp nz, plfightnewround
	xor a
	ret
deadcharAI:
	call closegrey
	call waitkey
	ld hl, youwinstring
	ld de, $1c36
	call drawstring
	ld b, 50
	call keyloop
	call pause
	ld hl, char1wins
	inc (hl)
	ld a, (rounds)
	cp (hl)
	jp nz, plfightnewround
	ret


pauseme:
	ld b, 1
	call keyloop
	and %00000100
	jr z, pauseme
movechar1:
	ld a, (difficulty)
	cp 5
	call z, getAImove
	ld a, (char1hit)
	or a
	call nz, char1hitgfx
	ld a, (char1jump)
	or a
	call nz, dojumpstuff
	ld a, (char1punch)
	or a
	jp nz, dopunchstuff
	ld a, (char1kick)
	or a
	jp nz, dokickstuff
	ld a, (keyvar)
	ld b, a
	and %00000001
	jr nz, pauseme
	ld a, b
	and %00010000
	call nz, startjump
	ld a, b
	and %00000010
	call nz, startpunch
	ld a, b
	and %00000100
	call nz, startkick
returnfromjumpkick:
	ld a, (keyvar)
	ld l, 0
	ld b, a
	and %01000000
	jr nz, moveleft
	ld a, b
	and %00100000
	jr nz, moveright
	ret
	
moveleft:
	ld a, (char2x)
	ld b, a
	ld a, (char1x)
	cp 2
	ret c
	cp b
	call c, dorightbig
	dec a
	dec a
finishmove:
	ld c, a
	ld a, (char1speed)
	ld b, a
	ld a, (mcounter)
	and b
	ret z
	ld a, l
	cp 1
	jr z, jumpingchar1					;if walking away from en. then he's not in the way
	ld a, (char1jump)					;jumping over character?
	cp 10
	jr c, nojchar1
	cp 29
	jr c, jumpingchar1
	ld a, (char2jump)					;walking under character?
	cp 10
	jr c, nojchar1
	cp 29
	jr c, jumpingchar1
nojchar1:
	ld a, (char2x)
	sub c
	add a, 5
	cp 11
	ret c
jumpingchar1:
	ld a, c
	ld (char1x), a
	ret
moveright:
	ld a, (char2x)
	ld b, a
	ld a, (char1x)
	cp 111
	ret nc
	cp b
	call nc, dorightbig
	inc a
	inc a
	jr finishmove
dorightbig:
	inc l
	ret

startjump:
	ld hl, char1jump
	ld a, (hl)
	or a
	ret nz
	ld a, 38
	ld (hl), a
	ret
dojumpstuff:
	dec a
	ld (char1jump), a
	ld c, a
	ld b, 0
	ld hl, charjumparc
	add hl, bc
	ld a, (hl)
	ld b, a
	ld a, (char1y)
	sub b
	ld (char1y), a
	ret

startkick:
	ld hl, char1kick
	ld a, (char1kickspeed)
	ld b, a
	ld a, (char1jump)
	or a
	jr z, skipassign99
	cp 29
	jr nc, skipassign99
	cp 10
	jr c, skipassign99
	ld b, 99
skipassign99:
	ld (hl), b
	ret
dokickstuff:
	cp 98
	jr nc, jumpkickstuff
	dec a
	ld (char1kick), a
	push af
	ld a, (char1kickpower)
	ld d, a
	ld a, (char1kickspeed)
	or a
	rra
	ld b, a
	ld a, (char1kspd3)
	ld c, a
	pop af
	cp b
	call z, puncheffect1
	ld hl, char1gfx
	cp c
	jr c, finishkickanim
	push af
	ld a, c
	add a, a
	ld c, a
	pop af
	cp c
	jr nc, finishkickanim
	ld a, 3
	ld (hl), a
	ret
finishkickanim
	ld a, 2
	ld (hl), a
	ret
jumpkickstuff:
	cp 98
	jr z, nokickdo
	ld a, (char1kickpower)
	ld d, a
	call puncheffect1
	ld a, c
	cp 255
	jr nz, nokickdo
	ld a, 98
	ld (char1kick), a
nokickdo:
	ld a, (char1jump)
	or a
	jr nz, keepitup
	ld (char1kick), a
keepitup:
	ld a, 4
	ld (char1gfx), a
	jp returnfromjumpkick

startpunch:
	ld a, (char1punchspeed)
	ld (char1punch), a
	ret
dopunchstuff:
	dec a
	ld (char1punch), a
	push af
	ld a, (char1punchpower)
	ld d, a
	pop af
	or a
	call z, puncheffect1
	ld a, 5
	ld (char1gfx), a
	ret
puncheffect1:
	ld c, 0
	ld a, (char1x)
	ld b, a
	ld a, (char2x)
	cp b
	call c, punchbackwards
	ld a, b
	add a, 10
	ld b, a
	ld a, (char2x)
	sub b
	add a, 4					;checks for within 4 pixels of perfect
	cp 8
	ret nc
	ld a, (char1y)
	ld b, a
	ld a, (char2y)				;close to 12 away up, 12 away down
	sub b
	add a, 12
	cp 24
	ret nc
	ld a, d
	jp hitchar2
punchbackwards:
	ld a, b
	sub 20
	ld b, a
	ret

hitchar2:
	ld b, a
	ld a, (char2goal)
	sub b
	jr c, deadchar2
	jr z, deadchar2
finishdchar2:
	ld (char2goal), a
	xor a
	ld (char1kick), a
	ld (char1punch), a
	ld c, 255
	ld a, (char2jump)
	or a
	jr nz, charfallhit
	ld a, 15
	ld (char2hit), a
	ret
charfallhit:
	ld a, 25
	ld (char2hit), a
	ret
deadchar2:
	ld a, 1
	jr finishdchar2

char1hitgfx:
	dec a
	ld (char1hit), a
	ld a, 6
	ld (char1gfx), a
	ret

drawchar1:
	ld hl, char1tempspr
	ld de, (char1oldxy)
	call drawgamespr
drawchar1b:
	ld a, (char1gfx)
	ld b, a
	ld de, 48
	ld hl, (char1pos)
	or a
	jr z, nogfxloop
dcharlp:
	add hl, de
	djnz dcharlp
nogfxloop:
	ld de, char1tempspr
	push de
	ld bc, 48
	ldir
	call checkflipleftright1
	pop hl
	ld de, (char1y)
	ld (char1oldxy), de
	call drawgamespr
	ld a, (counter)
	cp 33
	jr c, noassigntop
	ld b, 1
noassigntop:
	ld a, b
	ld (char1gfx), a
	ret

movechar2:
	call switchstats					;flip-flop player stats so I can utilize the same routines
	ld a, (difficulty)
	cp 6
	jr z, skipAImove
	call getAImove
skipAImove2:
	call movechar1						;no return so I can flip 'em right back
switchstats:
	ld hl, char1health
	ld de, char2health
	ld b, 26
sstatslp:
	ld a, (de)
	ld c, a
	ld a, (hl)
	ld (de), a
	ld (hl), c
	inc hl
	inc de
	djnz sstatslp
	ret
skipAImove:
	ld a, (keyvar)
	and %01000000
	jr nz, activateleft
	ld a, (keyvar)
	and %00100000
	call nz, activateright
	jr skipAImove2
activateleft
	ld a, (keyvar)
	xor %01000000
	or %00100000
	ld (keyvar), a
	jr skipAImove2
activateright:
	ld a, (keyvar)
	xor %00100000
	or %01000000
	ld (keyvar), a
	ret


drawchar2:
	ld hl, char2tempspr
	ld de, (char2oldxy)
	call drawgamespr
drawchar2b:
	ld a, (char2gfx)
	ld b, a
	ld de, 48
	ld hl, (char2pos)
	or a
	jr z, nogfxloop2
dcharlp2:
	add hl, de
	djnz dcharlp2
nogfxloop2:
	ld de, char2tempspr
	push de
	ld bc, 48
	ldir
	call checkflipleftright2
	pop hl
	ld de, (char2y)
	ld (char2oldxy), de
	call drawgamespr
	ld hl, counter
	inc (hl)
	ld a, (hl)
	cp 33
	jr nc, assigntop2
	xor a
	ld (char2gfx), a
	ret
assigntop2:
	cp 64
	jr nz, noresetcounter2
	xor a
	ld (hl), a
noresetcounter2
	ld a, 1
	ld (char2gfx), a
	ret

checkflipleftright1:
	ld a, (char2x)
	ld b, a
	ld a, (char1x)
	cp b
	jr nc, flipit1
	ret
flipit1:
	ld hl, char1tempspr
	jp flipsprite

checkflipleftright2:
	ld a, (char1x)
	ld b, a
	ld a, (char2x)
	cp b
	jr nc, flipit2
	ret
flipit2:
	ld hl, char2tempspr
	jp flipsprite

assigndefaults:
	ld a, 40
	ld (char1y), a
	ld (char2y), a
	ld a, 16
	ld (char1x), a
	ld (mcounter), a
	ld a, 56
	ld (char1goal), a
	ld (char2goal), a
	inc a
	ld (char1health), a
	ld (char2health), a
	ld a, 95
	ld (char2x), a
	ld (AIgoal), a
	call assignstuff
	call switchstats
	call assignstuff
	jp switchstats
assignstuff:
	xor a
	ld (char1hit), a
	ld (char1gfx), a
	ld (char1jump), a
	ld (char1punch), a
	ld (char1kick), a
	ld a, (char1num)
	inc a
	ld de, 336
	ld hl, $8119-336
	ld b, a
assigncharpos:
	add hl, de
	djnz assigncharpos
	ld (char1pos), hl
	ld a, (char1num)
	ld e, a
	ld d, 0
	ld l, a
	ld h, d
	add hl, de
	add hl, de
	add hl, hl
	ld de, charstats
	add hl, de
	ld de, char1punchpower
	ld bc, 6
	ldir
	ret

updatehealth:								;updates health bar
	ld a, (char1goal)
	ld b, a
	ld a, (char1health)
	cp b
	jr z, checkoutc2hth
	dec a
	ld (char1health), a
checkoutc2hth:
	ld a, (char2goal)
	ld b, a
	ld a, (char2health)
	cp b
	jr z, nodoch2
	dec a
	ld (char2health), a
nodoch2:
	ld b, 32
	xor a
	ld h, $fc
	ld l, a
uhealthlp1:
	ld (hl), a
	inc hl
	djnz uhealthlp1
	ld a, (char1health)
	ld b, a
	ld l, 0
	ld c, %10000000
uhealthlp2:
	ld a, c
	or (hl)
	ld (hl), a
	rrc c
	jr nc, noinchlth
	inc hl
noinchlth
	djnz uhealthlp2
	ld a, (char2health)
	ld b, a
	ld l, 15
	ld c, %00000001
uhealthlp3:
	ld a, c
	or (hl)
	ld (hl), a
	rlc c
	jr nc, nodechlth
	dec hl
nodechlth:
	djnz uhealthlp3
	ld l, b
	ld d, h
	ld e, 16
	ld c, e
	ldir
	ret

char1health:
	.db 0
char1y:
	.db 0
char1x:
	.db 0
char1gfx:
	.db 0
char1pos:
	.dw 0
char1num:
	.db 0
char1jump:
	.db 0
char1kick:
	.db 0
char1punch:
	.db 0
char1oldxy:
	.dw 0
char1goal:
	.db 0
char1hit:
	.db 0
char1punchpower:
	.db 0
char1kickpower:
	.db 0
char1kickspeed:
	.db 0
char1punchspeed:
	.db 0
char1kspd3:
	.db 0
char1speed:
	.db 0
AI2goal:
	.db 0
AI2attack:
	.db 0
AI2jump:
	.db 0
AI2steps:
	.db 0
AI2kick:
	.db 0
AI2punch:
	.db 0

char2health:
	.db 0
char2y:
	.db 0
char2x:
	.db 0
char2gfx:
	.db 0
char2pos:
	.dw 0
char2num:
	.db 1
char2jump:
	.db 0
char2kick:
	.db 0
char2punch:
	.db 0
char2oldxy:
	.dw 0
char2goal:
	.db 0
char2hit:
	.db 0
char2punchpower:
	.db 0
char2kickpower:
	.db 0
char2kickspeed:
	.db 0
char2punchspeed:
	.db 0
char2kspd3:
	.db 0
char2speed:
	.db 0
AIgoal:
	.db 0
AIattack:
	.db 0
AIjump:
	.db 0
AIsteps:
	.db 0
AIkick:
	.db 0
AIpunch:
	.db 0

counter:
	.db 0
mcounter:
	.db 0

curround:
	.db 0
char1wins:
	.db 0
char2wins:
	.db 0, 0

charstats:
;punch power, kick power, k speed, p speed, kspeed/3, char speed
	.db 6, 11, 30, 10, 10, %01010111			;Gifel
	.db 6, 5, 15, 15, 5, %11111111				;Sticko
	.db 9, 14, 42, 7, 14, %01010101				;Wise Nekwa
	.db 12, 18, 45, 30, 15, %01000100			;Kykleptikottern
	.db 1, 2, 9, 4, 3, %11110111				;Sboob Gib
	.db 7, 10, 24, 12, 8, %01010101				;Hypo-Radio Gel
	.db 4, 16, 24, 10, 8, %01110111				;Yugi
	.db 0, 15, 15, 30, 5, %11110111				;Fogger
	.db 14, 20, 21, 12, 7, %01010111			;Mr. Brick
	.db 21, 54, 18, 15, 6, %01110111			;Bogy Shortcircuit
	.db 11, 15, 15, 8, 5, %11110111				;Robbie
	.db 14, 14, 18, 6, 6, %01010111				;Maximilian
EIstats:
	.db 3,3,30,20,10,%00010001					;EI Stamina

charjumparc:
	.db 252, 252, 253, 253, 253, 254, 254, 254, 254, 254, 254
	.db 254, 254, 254, 255, 255, 255, 0, 0
	.db 0, 0, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 4, 4

char1tempspr:
	.dw 0,0,0,0,0,0,0,0
	.dw 0,0,0,0,0,0,0,0
	.dw 0,0,0,0,0,0,0,0

char2tempspr:
	.dw 0,0,0,0,0,0,0,0
	.dw 0,0,0,0,0,0,0,0
	.dw 0,0,0,0,0,0,0,0

charnames:
	.db 0
	.text "Gifel"
	.text "Sticko"
	.text "Wise Nekwa"
	.text "Kykleptokottern"
	.text "Sboob Gib"
	.text "Hypo-Radio Gel"
	.text "Yugi"
	.text "Fogger"
	.text "Mr. Brick"
	.text "Bogy Shortcircuit"
	.text "Robbie"
	.text "Maximilian"
	.text "EI Stamina"

vsstring:
	.text "VS."
youlosestring:
	.text "You lost!"
youwinstring:
	.text "You Won!"
roundstring:
	.text "ROUND"
matchstring:
	.text "MATCH"

.end
