tournament:
	ld hl, 0
	ld (score), hl
	call characterselect
	ld (char1num), a
	call clearscreen
	ld hl, storystring
	call tellstory
tournamentloop:
	call clearscreen
	call drawface
	ld a, (match)
	dec a
	ld (char2num), a
	ld hl, char1string
	ld de, $3001
	call drawseriesthing
	call pause
	call playfight
	or a
	jr z, diedtournament
	ld a, (match)
	cp 10
	jr z, finishedtournament
	call clearscreen
	ld de, $1a10
	ld hl, contstring
	call drawstring
	ld de, $2010
	ld hl, nmatch
	call drawstring
	ld a, (match)
	inc a
	ld (match), a
	dec a
	ld de, $2040
	call drawcharname
	call pause
	jr tournamentloop
diedtournament:
	ld a, (losingmessage)
	or a
	ret z
	call clearscreen
	call drawface
	ld a, (char2num)
	ld hl, deadstring
	ld de, $3001
	call drawseriesthing
	call pause
	ret
finishedtournament:
	ld hl, winstring
	ld de, $1a10
	call drawstring
	ld a, (difficulty)
	cp 4
	jr z, skipucheck
	cp 2
	jr nz, noupgrade
skipucheck:
	ld a, (char1num)
	ld hl, unlockstring
	ld de, $2010
	call drawseriesthing
	call dogetstuff
noupgrade:
	jp pause

dogetstuff:
	ld de, unlocktable
	ld a, (char1num)
	cp 12
	jr z, beatgame
	ld l, a
	ld h, 0
	add hl, hl
	add hl, de
	ld e, (hl)
	inc hl
	ld d, (hl)
	ld a, 1
	ld (de), a
	ret
beatgame:
	call pause
	pop hl
	call clearscreen
	ld hl, beatgamestring
	jr tellstory

score:
	.dw 0

tellstory:
	ld de, $0b06
	call drawstring
	ld d, $12
	call drawstring
	ld d, $19
	call drawstring
	ld d, $20
	call drawstring
	ld d, $27
	call drawstring
	ld d, $2e
	call drawstring
	ld a, 8
	call hline
	ld a, 56
	call hline
	jp pause

unlocktable:
	.dw availablechars+6, availablechars+7, availablechars+10, availablechars+11
	.dw trainingdiff, charstatsshow, availablechars+8, availablechars+9
	.dw difficultdiff, losingmessage, doubleaidiff, twochardiff

storystring:
	.text "'Welcome all to the King of the"
	.text "Fighters competition, to be"
	.text "commemorated world wide on the"
	.text "TI 86! This year participants"
	.text "from all the galaxy will compete"
	.text "to win absolutely nothing!"

beatgamestring
	.text "Congrats! You've beaten the game!"
	.text "By: Thomas Williamson"
	.text "Character Design: John Sheehan"
	.db 0
	.text "Make sure you've beaten the"
	.text "tournament with all 13 chars!"

Char1string:
	.db 0
	.text "I will eat your liver!"
	.text "Sticks + stones'll break your bones!"
	.text "I vant to vin dis tournament!"
	.text "I drink to your slow defeat!"
	.text "Gawk at my large....abilities!"
	.text "Bbbb Grgagahhss bahaasd!!!!"
	.text "Forget it! My sword wins."
	.text "It's a wee bit foggy, eh?"
	.text "I'll lay you like a mason!"
	.text "Noone beats the a champion..."

Contstring:
	.text "You continue in the tournament!"
nmatch:
	.text "Next match...."

Deadstring:
	.db 0
	.text "Mmm.. your flesh does body good!"
	.text "No firewood for you tonight!"
	.text "Vell, I guess you vost!"
	.text "I told you capitalism was a failure."
	.text "Try looking at my face next time!"
	.text "BbbqYOUdsaf mananamSUCKdjaaaal!"
	.text "Your body was placed with the others."
	.text "Shuda watched the weatha this mournin."
	.text "You're no trouble for a pile of rubble!"
	.text "What I do? Lick you to death?"

Winstring:
	.text "You won the tournament!"

Unlockstring:
	.db 0
	.text "Got Yugi!"
	.text "Fogger joined the ranks!"
	.text "Robbie skated on over."
	.text "Maximilian dogged his way in!"
	.text "Got a new difficulty level!"
	.text "You can now view player stats!"
	.text "Mr. Brick came along..."
	.text "Bogy Shortcircuit is available!"
	.text "More difficulty levels!"
	.text "Losing message now unlocked!"
	.text "Double AI diff. level!"
	.text "Freaky diff. level unlocked!"
	.text "You beat the game!"

drawface:
	ld a, 8
	call hline
	ld a, 56
	call hline
	ld a, (match)
	ld b, a
	ld hl, facedata-48
	ld de, 48
getfaceloop:
	add hl, de
	djnz getfaceloop
	ld de, $3810
	jp drawspr2416
Facedata:
 ;Tile 0
 .db $0F,$80,$3F,$F8,$40,$04,$E0,$0E,$FF,$FE,$FF,$FE,$9F,$F2,$8C,$62
 .db $95,$52,$9D,$72,$8D,$62,$81,$02,$82,$02,$84,$02,$47,$84,$40,$04
 .db $5F,$F4,$55,$54,$6F,$EC,$2A,$A8,$2F,$E8,$20,$08,$18,$30,$07,$C0
 ;Tile 1
 .db $00,$00,$00,$00,$00,$00,$01,$E0,$03,$F0,$07,$F8,$0F,$FC,$1F,$FC
 .db $1F,$FC,$1E,$FC,$1F,$FE,$0F,$FE,$1F,$FE,$3F,$FE,$7F,$FE,$7F,$FE
 .db $7F,$FE,$3F,$FE,$1D,$F8,$40,$50,$40,$D0,$F0,$10,$F0,$10,$3F,$10
 ;Tile 2
 .db $00,$00,$1F,$C0,$7F,$E0,$E0,$60,$89,$20,$96,$B0,$99,$B0,$80,$30
 .db $84,$10,$86,$10,$80,$10,$BF,$90,$9F,$10,$80,$30,$80,$28,$E4,$46
 .db $EF,$41,$3F,$C0,$1F,$C0,$1F,$E0,$0F,$E0,$07,$F8,$03,$FF,$00,$FE
 ;Tile 3
 .db $00,$00,$00,$00,$03,$C0,$1E,$38,$10,$0C,$20,$04,$22,$32,$26,$4B
 .db $20,$45,$2C,$05,$38,$05,$10,$09,$11,$80,$20,$80,$20,$80,$13,$00
 .db $0D,$F0,$07,$F8,$07,$E0,$0F,$80,$1F,$7C,$18,$04,$00,$02,$00,$03
 ;Tile 4
 .db $00,$00,$00,$00,$00,$00,$07,$C0,$1F,$F8,$3C,$3C,$38,$1E,$7A,$2E
 .db $70,$86,$F0,$46,$E0,$C7,$F4,$13,$F3,$E3,$F3,$E7,$F8,$0F,$7F,$FF
 .db $7C,$1F,$7C,$1E,$7C,$0E,$60,$02,$C0,$01,$80,$00,$90,$84,$20,$82
 ;Tile 5
 .db $1F,$E0,$10,$10,$20,$08,$20,$04,$20,$04,$40,$02,$50,$12,$58,$32
 .db $9C,$72,$80,$02,$80,$01,$80,$01,$A0,$06,$B0,$06,$B0,$04,$B8,$04
 .db $1C,$0C,$1E,$1C,$0F,$B8,$03,$F8,$01,$F1,$00,$02,$00,$04,$00,$08
 ;Tile 6
 .db $00,$00,$0F,$F0,$3F,$FC,$23,$C4,$20,$04,$28,$16,$6C,$36,$60,$06
 .db $65,$26,$61,$06,$E1,$46,$E1,$86,$E0,$07,$F0,$17,$F7,$E7,$F0,$07
 .db $F0,$0F,$B8,$1F,$B7,$EF,$F0,$0F,$E0,$07,$20,$04,$18,$08,$0F,$F0
 ;Tile 7
 .db $00,$00,$00,$00,$00,$00,$07,$FE,$0F,$FE,$16,$06,$2E,$06,$56,$66
 .db $2E,$96,$56,$66,$2E,$06,$56,$06,$2F,$FE,$17,$FE,$2A,$A8,$15,$54
 .db $2A,$A8,$55,$54,$2A,$A8,$55,$50,$AA,$A0,$55,$00,$AA,$00,$50,$00
 ;Tile 8
 .db $0C,$00,$B4,$97,$FF,$FF,$00,$30,$1F,$30,$2E,$B0,$4A,$56,$2E,$9E
 .db $1F,$F6,$FF,$02,$02,$06,$06,$02,$02,$57,$AD,$BF,$7F,$CA,$C0,$18
 .db $C0,$18,$40,$28,$DC,$DF,$FF,$F7,$00,$25,$03,$FE,$01,$02,$BB,$FC
 ;Tile 9
 .db $07,$FF,$1B,$7D,$2A,$AA,$54,$50,$60,$00,$A7,$FC,$CF,$FE,$8F,$FE
 .db $EE,$0E,$CE,$0E,$CE,$4E,$AE,$4E,$CE,$0E,$EE,$0E,$CF,$FE,$8F,$FE
 .db $D7,$FC,$C0,$00,$E0,$01,$C8,$02,$A0,$04,$D0,$04,$C8,$08,$E0,$08
.end
